



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用X264编码yuv格式的视频帧使用ffmpeg解码h264视频帧</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用X264编码yuv格式的视频帧使用ffmpeg解码h264视频帧</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-28 20:24:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h2>前面一篇博客介绍在centos上搭建<a href="http://blog.csdn.net/sjin_1314/article/details/41142665" rel="external nofollow noreferrer">点击打开链接</a>ffmpeg及x264开发环境。以下就来问个样例：</h2>
<h2>1、利用x264库将YUV格式视频文件编码为h264格式视频文件</h2>
<h2>2、利用ffmpeh库将h264格式的视频文件解码为yuv格式视频文件</h2>
<h2>解码和编码前后对文件大小进行比較，如图：</h2>
<h2><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141116105421468?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvc2ppbl8xMzE0/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></h2>
<h2>当中yuv420p.yuv为原始文件，大小77M</h2>
<h2>encode.h264为H264编码后的视频文件，大小1.4M</h2>
<h2>decode.yuv为ffmpeg解码后的视频文件，大小77M。</h2>
<h2>从文件的大小非常明显能够看出h264压缩率。在Ｗｉｎｄｏｗｓ平台分辨播放了三个文件，画面看不出差别。</h2>
<h2>以下是代码＂</h2>
<h2><pre class="prettyprint linenums">/*File : yuvTO264.c<br />
 *Auth : sjin<br />
 *Date : 20141115<br />
 *Mail : 413977243@qq.com<br />
 */

/*利用x264库将YUV文件编码为h264文件<br />
 *<br />
 */

#include &lt;stdint.h&gt;<br />
#include &lt;x264.h&gt;<br />
#include &lt;stdio.h&gt;<br />
#include &lt;unistd.h&gt;<br />
#include &lt;fcntl.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;string.h&gt;

#define CLEAR(x) (memset((&amp;x),0,sizeof(x)))<br />
#define IMAGE_WIDTH   176<br />
#define IMAGE_HEIGHT  144<br />
#define ENCODER_PRESET &quot;veryfast&quot;

/*配置參数<br />
 * 使用默认參数，在这里使用了zerolatency的选项，使用这个选项之后，就不会有<br />
 * delayed_frames，假设你使用不是这个的话，还须要在编码完毕之后得到缓存的<br />
 * 编码帧<br />
 */<br />
#define ENCODER_TUNE   &quot;zerolatency&quot;<br />
#define ENCODER_PROFILE  &quot;baseline&quot;<br />
#define ENCODER_COLORSPACE X264_CSP_I420

typedef struct my_x264_encoder{<br />
        x264_param_t  * x264_parameter;<br />
        char parameter_preset[20];<br />
        char parameter_tune[20];<br />
        char parameter_profile[20];<br />
        x264_t  * x264_encoder;<br />
        x264_picture_t * yuv420p_picture;<br />
        long colorspace;<br />
        unsigned char *yuv;<br />
        x264_nal_t * nal;<br />
} my_x264_encoder;

char *read_filename=&quot;yuv420p.yuv&quot;;<br />
char *write_filename=&quot;encode.h264&quot;;

int main(int argc ,char **argv)<br />
{<br />
        int ret;<br />
        int fd_read,fd_write;<br />
        my_x264_encoder * encoder = (my_x264_encoder *)malloc(sizeof(my_x264_encoder));<br />
        if(!encoder){<br />
                printf(&quot;cannot malloc my_x264_encoder !\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }<br />
        CLEAR(*encoder);

        /****************************************************************************<br />
         * Advanced parameter handling functions<br />
         ****************************************************************************/

        /* These functions expose the full power of x264's preset-tune-profile system for<br />
         * easy adjustment of large numbers //free(encoder-&gt;yuv420p_picture);of internal parameters.<br />
         *<br />
         * In order to replicate x264CLI's option handling, these functions MUST be called<br />
         * in the following order:<br />
         * 1) x264_param_default_preset<br />
         * 2) Custom user options (via param_parse or directly assigned variables)<br />
         * 3) x264_param_apply_fastfirstpass<br />
         * 4) x264_param_apply_profile<br />
         *<br />
         * Additionally, x264CLI does not apply step 3 if the preset chosen is &quot;placebo&quot;<br />
         * or --slow-firstpass is set. */<br />
        strcpy(encoder-&gt;parameter_preset,ENCODER_PRESET);<br />
        strcpy(encoder-&gt;parameter_tune,ENCODER_TUNE);

        encoder-&gt;x264_parameter = (x264_param_t *)malloc(sizeof(x264_param_t));<br />
        if(!encoder-&gt;x264_parameter){<br />
                printf(&quot;malloc x264_parameter error!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }

    /*初始化编码器*/<br />
        CLEAR(*(encoder-&gt;x264_parameter));<br />
        x264_param_default(encoder-&gt;x264_parameter);

        if((ret = x264_param_default_preset(encoder-&gt;x264_parameter,encoder-&gt;parameter_preset,encoder-&gt;parameter_tune))&lt;0){<br />
                printf(&quot;x264_param_default_preset error!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }

    /*cpuFlags 去空缓冲区继续使用不死锁保证*/<br />
        encoder-&gt;x264_parameter-&gt;i_threads               =X264_SYNC_LOOKAHEAD_AUTO;<br />
    /*视频选项*/<br />
        encoder-&gt;x264_parameter-&gt;i_width                 =IMAGE_WIDTH;//要编码的图像的宽度<br />
        encoder-&gt;x264_parameter-&gt;i_height                =IMAGE_HEIGHT;//要编码的图像的高度<br />
        encoder-&gt;x264_parameter-&gt;i_frame_total   =0;//要编码的总帧数，不知道用0<br />
        encoder-&gt;x264_parameter-&gt;i_keyint_max    =25;<br />
    /*流參数*/<br />
        encoder-&gt;x264_parameter-&gt;i_bframe        =5;<br />
        encoder-&gt;x264_parameter-&gt;b_open_gop      =0;<br />
        encoder-&gt;x264_parameter-&gt;i_bframe_pyramid=0;<br />
        encoder-&gt;x264_parameter-&gt;i_bframe_adaptive=X264_B_ADAPT_TRELLIS;

    /*log參数，不须要打印编码信息时直接凝视掉*/<br />
        encoder-&gt;x264_parameter-&gt;i_log_level    =X264_LOG_DEBUG;

        encoder-&gt;x264_parameter-&gt;i_fps_den               =1;//码率分母<br />
        encoder-&gt;x264_parameter-&gt;i_fps_num               =25;//码率分子<br />
        encoder-&gt;x264_parameter-&gt;b_intra_refresh =1;<br />
        encoder-&gt;x264_parameter-&gt;b_annexb                =1;

        strcpy(encoder-&gt;parameter_profile,ENCODER_PROFILE);<br />
        if((ret=x264_param_apply_profile(encoder-&gt;x264_parameter,encoder-&gt;parameter_profile))&lt;0){<br />
                printf(&quot;x264_param_apply_profile error!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }<br />
    /*打开编码器*/<br />
        encoder-&gt;x264_encoder = x264_encoder_open(encoder-&gt;x264_parameter);<br />
        encoder-&gt;colorspace = ENCODER_COLORSPACE;

    /*初始化pic*/<br />
        encoder-&gt;yuv420p_picture = (x264_picture_t *)malloc(sizeof(x264_picture_t ));<br />
        if(!encoder-&gt;yuv420p_picture){<br />
                printf(&quot;malloc encoder-&gt;yuv420p_picture error!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }<br />
        if((ret = x264_picture_alloc(encoder-&gt;yuv420p_picture,encoder-&gt;colorspace,IMAGE_WIDTH,IMAGE_HEIGHT))&lt;0){<br />
                printf(&quot;ret=%d\n&quot;,ret);<br />
                printf(&quot;x264_picture_alloc error!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }

        encoder-&gt;yuv420p_picture-&gt;img.i_csp = encoder-&gt;colorspace;<br />
        encoder-&gt;yuv420p_picture-&gt;img.i_plane = 3;<br />
        encoder-&gt;yuv420p_picture-&gt;i_type = X264_TYPE_AUTO;

    /*申请YUV buffer*/<br />
        encoder-&gt;yuv = (uint8_t *)malloc(IMAGE_WIDTH*IMAGE_HEIGHT*3/2);<br />
        if(!encoder-&gt;yuv){<br />
                printf(&quot;malloc yuv error!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }<br />
        CLEAR(*(encoder-&gt;yuv));<br />
        encoder-&gt;yuv420p_picture-&gt;img.plane[0] = encoder-&gt;yuv;<br />
        encoder-&gt;yuv420p_picture-&gt;img.plane[1] = encoder-&gt;yuv+IMAGE_WIDTH*IMAGE_HEIGHT;<br />
        encoder-&gt;yuv420p_picture-&gt;img.plane[2] = encoder-&gt;yuv+IMAGE_WIDTH*IMAGE_HEIGHT+IMAGE_WIDTH*IMAGE_HEIGHT/4;

        if((fd_read = open(read_filename,O_RDONLY))&lt;0){<br />
                printf(&quot;cannot open input file!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }

        if((fd_write = open(write_filename,O_WRONLY | O_APPEND | O_CREAT,0777))&lt;0){<br />
                printf(&quot;cannot open output file!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }

        int n_nal = 0;<br />
        x264_picture_t pic_out;<br />
        x264_nal_t *my_nal;<br />
        encoder-&gt;nal = (x264_nal_t *)malloc(sizeof(x264_nal_t ));<br />
        if(!encoder-&gt;nal){<br />
                printf(&quot;malloc x264_nal_t error!\n&quot;);<br />
                exit(EXIT_FAILURE);<br />
        }<br />
        CLEAR(*(encoder-&gt;nal));

    /*编码*/<br />
        while(read(fd_read,encoder-&gt;yuv,IMAGE_WIDTH*IMAGE_HEIGHT*3/2)&gt;0){<br />
                encoder-&gt;yuv420p_picture-&gt;i_pts++;<br />
                if((ret = x264_encoder_encode(encoder-&gt;x264_encoder,&amp;encoder-&gt;nal,&amp;n_nal,encoder-&gt;yuv420p_picture,&amp;pic_out))&lt;0){<br />
                        printf(&quot;x264_encoder_encode error!\n&quot;);<br />
                        exit(EXIT_FAILURE);<br />
                }

                for(my_nal = encoder-&gt;nal; my_nal&lt;encoder-&gt;nal+n_nal; ++my_nal){<br />
                        write(fd_write,my_nal-&gt;p_payload,my_nal-&gt;i_payload);<br />
                }<br />
        }

        free(encoder-&gt;yuv);<br />
        free(encoder-&gt;yuv420p_picture);<br />
        free(encoder-&gt;x264_parameter);<br />
        x264_encoder_close(encoder-&gt;x264_encoder);<br />
        free(encoder);<br />
        close(fd_read);<br />
        close(fd_write);

        return 0;<br />
}
</pre>
<p><pre class="prettyprint linenums">/*File : decode_h264.c<br />
 *Auth : sjin<br />
 *Date : 20141115<br />
 *Mail : 413977243@qq.com<br />
 */

/*将h264解码为yuv文件*/

#include &lt;stdio.h&gt;<br />
#include &lt;string.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;fcntl.h&gt;<br />
#include &lt;unistd.h&gt;<br />
#include &lt;libavcodec/avcodec.h&gt;<br />
#include &lt;libavformat/avformat.h&gt;<br />
#include &lt;libavutil/mathematics.h&gt;

#define DECODED_OUTPUT_FORMAT  AV_PIX_FMT_YUV420P<br />
#define INPUT_FILE_NAME &quot;encode.h264&quot;<br />
#define OUTPUT_FILE_NAME &quot;decode.yuv&quot;<br />
/*h264文件的宽度和高度，必须和实际的宽度和高度一致<br />
 *否则将出错<br />
 * */<br />
#define IMAGE_WIDTH  176<br />
#define IMAGE_HEIGHT 144

void error_handle(const char *errorInfo )<br />
{<br />
	printf(&quot;%s error!\n&quot;,errorInfo);<br />
	exit(EXIT_FAILURE);<br />
}

int main(int argc,char ** argv)<br />
{<br />
	int  write_fd,ret,videoStream;<br />
	AVFormatContext * formatContext=NULL;<br />
	AVCodec * codec;<br />
	AVCodecContext * codecContext;<br />
	AVFrame * decodedFrame;<br />
	AVPacket packet;<br />
	uint8_t *decodedBuffer;<br />
	unsigned int decodedBufferSize;<br />
	int finishedFrame;

    //初始化环境<br />
	av_register_all();

	write_fd = open(OUTPUT_FILE_NAME,O_RDWR | O_CREAT,0666);<br />
	if(write_fd&lt;0){<br />
		perror(&quot;open&quot;);<br />
		exit(1);<br />
	}

	ret = avformat_open_input(&amp;formatContext, INPUT_FILE_NAME, NULL,NULL);<br />
	if(ret&lt;0)<br />
		error_handle(&quot;avformat_open_input error&quot;);

	ret = avformat_find_stream_info(formatContext,NULL);<br />
	if(ret&lt;0)<br />
		error_handle(&quot;av_find_stream_info&quot;);

    //打印输入文件的具体信息<br />
    av_dump_format(formatContext,0,INPUT_FILE_NAME,0);

	videoStream = 0;<br />
	codecContext = formatContext-&gt;streams[videoStream]-&gt;codec;

	codec = avcodec_find_decoder(AV_CODEC_ID_H264);<br />
	if(codec == NULL)<br />
		error_handle(&quot;avcodec_find_decoder error!\n&quot;);

	ret = avcodec_open2(codecContext,codec,NULL);<br />
	if(ret&lt;0)<br />
		error_handle(&quot;avcodec_open2&quot;);

    //分配保存视频帧的空间<br />
	decodedFrame = avcodec_alloc_frame();<br />
	if(!decodedFrame)<br />
		error_handle(&quot;avcodec_alloc_frame!&quot;);

    //分配解码后视频帧的空间<br />
	decodedBufferSize = avpicture_get_size(DECODED_OUTPUT_FORMAT,IMAGE_WIDTH,IMAGE_HEIGHT);<br />
	decodedBuffer = (uint8_t *)malloc(decodedBufferSize);<br />
	if(!decodedBuffer)<br />
		error_handle(&quot;malloc decodedBuffer error!&quot;);

	av_init_packet(&amp;packet);<br />
	while(av_read_frame(formatContext,&amp;packet)&gt;=0){<br />
			ret = avcodec_decode_video2(codecContext,decodedFrame,&amp;finishedFrame,&amp;packet);<br />
			if(ret&lt;0)<br />
				error_handle(&quot;avcodec_decode_video2 error!&quot;);<br />
			if(finishedFrame){<br />
				avpicture_layout((AVPicture*)decodedFrame,DECODED_OUTPUT_FORMAT,IMAGE_WIDTH,IMAGE_HEIGHT,decodedBuffer,decodedBufferSize);<br />
				ret = write(write_fd,decodedBuffer,decodedBufferSize);<br />
				if(ret&lt;0)<br />
					error_handle(&quot;write yuv stream error!&quot;);<br />
			}

		av_free_packet(&amp;packet);<br />
	}

    /*防止视频解码完毕后丢帧的情况*/<br />
	while(1){<br />
		packet.data = NULL;<br />
		packet.size = 0;<br />
		ret = avcodec_decode_video2(codecContext,decodedFrame,&amp;finishedFrame,&amp;packet);<br />
		if(ret&lt;=0 &amp;&amp; (finishedFrame&lt;=0))<br />
			break;<br />
		if(finishedFrame){<br />
			avpicture_layout((AVPicture*)decodedFrame,DECODED_OUTPUT_FORMAT,IMAGE_WIDTH,IMAGE_HEIGHT,decodedBuffer,decodedBufferSize);<br />
			ret = write(write_fd,decodedBuffer,decodedBufferSize);<br />
			if(ret&lt;0)<br />
				error_handle(&quot;write yuv stream error!&quot;);<br />
		}

		av_free_packet(&amp;packet);<br />
	}

	avformat_close_input(&amp;formatContext);<br />
	free(decodedBuffer);<br />
	av_free(decodedFrame);<br />
	avcodec_close(codecContext);

	return 0;<br />
}
</pre>
<p>Makefile:</h2>
<div>
<pre class="prettyprint linenums"># use pkg-config for getting CFLAGS and LDLIBS<br />
FFMPEG_LIBS=    libavdevice                        \<br />
                libavformat                        \<br />
                libavfilter                        \<br />
                libavcodec                         \<br />
                libswresample                      \<br />
                libswscale                         \<br />
                libavutil                          \

CFLAGS += -Wall -O2 -g<br />
CFLAGS := $(shell pkg-config --cflags $(FFMPEG_LIBS)) $(CFLAGS)<br />
LDLIBS := $(shell pkg-config --libs $(FFMPEG_LIBS)) $(LDLIBS)

EXAMPLES= decode_h264 yuvTO264

OBJS=$(addsuffix .o,$(EXAMPLES))

# the following examples make explicit use of the math library<br />
LDLIBS += -lx264 -m32 -pthread -lm -ldl

.phony:all clean

all: $(OBJS) $(EXAMPLES)

clean:<br />
	rm $(EXAMPLES) $(OBJS)
</pre>
<p>參考资料：</div>
<div>參考资料<br />1、http://blog.csdn.net/liushu1231/article/details/9203239<br />2、http://www.cnblogs.com/fojian/archive/2012/09/01/2666627.html<br />3、http://stackoverflow.com/questions/2940671/how-does-one-encode-a-series-of-images-into-h264-using-the-x264-c-api<br />4、http://blog.yikuyiku.com/?p=3486</div>
<h2><h3><a href="http://download.csdn.net/detail/yong_hen/8165971" rel="external nofollow noreferrer">live555搭建的rtspserver发送当前屏幕（x264)</a></h3></h2>
<div></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ov22pq.html">php 设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwrjdr9.html">php大力力：技术排错过程中，关键点总结和心情历程&lpar;2015-10-19&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93v2y08.html">简述jsp之EL表达式和jstl及其使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kr6r5q.html">Java分布式开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zlzovq.html">Spring的反射机制和依赖注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvyg6yq.html">NodeJS Hello world</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6rxj8.html">20135202闫佳歆--week 9  期中总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1j6o79.html">FS4412系统移植</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdm45e8.html">linux 文件、文件夹的重命名命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z17z2n9.html">【转】 C&plus;&plus;库常用函数一览</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v6jpj8.html">&lpar;转&rpar;IIS5&period;1的安装配置并发布ASP&period;NET网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7m4d8.html">linux mysql密码破解一张图解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o6nzy9.html">python邮件发送脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zo0zx9.html">VS SQL  出现&percnt;CommonDir&percnt;dte80a&period;olb  该解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kjm169.html">用phpcms如何将静态页面制作成企业网站，头部加尾部</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp4pd39.html">motan负载均衡&sol;zookeeper集群&sol;zookeeper负载均衡的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj07n1q.html">Swift-函数学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/96prdzy8.html">带着新人看java虚拟机01</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yz2lz8.html">JavaScript中数据类型判断</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpx1o39.html">sqli注入--利用information&lowbar;schema配合双查询报错注入</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gem0648.html">Java并发编程--Fork&sol;Join框架使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljmdnx9.html">ONVIFclient搜索设备获取rtsp解决开发笔记&lpar;精华文章&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxknj0v8.html">iOS文件保存策略</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey1goe9.html">SQL简单的日报和月报</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj1op38.html">Linux Server</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz0wle8.html">DEDE使用AJAX无刷新提交Form表单，PHP返回结果</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdjz3d9.html">﻿﻿﻿﻿﻿﻿ORA-16525&colon; the Data Guard broker is not yet available</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdjz7d9.html">（40）JS运动之右下角悬浮框</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mengvpq.html">Android自己定义控件实战&mdash;&mdash;仿淘宝商品浏览界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp135r9.html">Balsamiq Mockups注册码</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
